# generated by datamodel-codegen:
#   filename:  HelloAssoV5OpenAPI.json
#   timestamp: 2024-04-28T15:09:13+00:00

from __future__ import annotations

from datetime import datetime
from typing import Annotated, Any

from pydantic import BaseModel, StringConstraints

from helloasso_api_wrapper.models import statistics


class CheckoutTerm(BaseModel):
    amount: int
    date: datetime


class CheckoutPayer(BaseModel):
    firstName: Annotated[str, StringConstraints(max_length=255)] | None = None
    lastName: Annotated[str, StringConstraints(max_length=255)] | None = None
    email: Annotated[str, StringConstraints(max_length=255)] | None = None
    dateOfBirth: datetime | None = None
    address: str | None = None
    city: str | None = None
    zipCode: str | None = None
    country: Annotated[str, StringConstraints(min_length=3, max_length=3)] | None = None
    companyName: Annotated[str, StringConstraints(max_length=255)] | None = None


class InitCheckoutResponse(BaseModel):
    id: int  # checkoutIntentId
    redirectUrl: str


class InitCheckoutBody(BaseModel):
    """
    When the order or a payment is done, HelloAsso will call the webhook including `metadata` in the `NotificationResultContent` body
    """

    totalAmount: int
    initialAmount: int
    itemName: Annotated[str, StringConstraints(max_length=250)]
    backUrl: str
    errorUrl: str
    returnUrl: str
    containsDonation: bool
    terms: list[CheckoutTerm] | None = None
    payer: CheckoutPayer | None = None
    metadata: dict[str, Any] | None = None


class CheckoutIntentResponse(BaseModel):
    metadata: dict[str, Any] | None = None
    order: statistics.OrderDetail | None = None
    id: int | None = None
    redirectUrl: str | None = None
