# generated by datamodel-codegen:
#   filename:  HelloAssoV5OpenAPI.json
#   timestamp: 2024-04-28T15:09:13+00:00

from __future__ import annotations

from datetime import datetime

from pydantic import BaseModel

from helloasso_api_wrapper.models import enums, forms, organization, shared


class ListFormsRequest(BaseModel):
    formName: str | None = None
    formDescription: str | None = None
    formZipCodes: list[str] | None = None
    formCities: list[str] | None = None
    formRegions: list[str] | None = None
    formDepartments: list[str] | None = None
    formCountries: list[str] | None = None
    formTypes: list[enums.FormType] | None = None
    formActivityType: list[str] | None = None
    formPublicationStartDateMin: datetime | None = None
    formPublicationStartDateMax: datetime | None = None
    formStartDateMin: datetime | None = None
    formStartDateMax: datetime | None = None
    formEndDateMax: datetime | None = None
    formEndDateMin: datetime | None = None
    formIsFree: bool | None = None
    formHasRemainingEntries: bool | None = None
    formInternalTags: list[str] | None = None
    formPublicTags: list[str] | None = None
    organizationName: str | None = None
    organizationDescription: str | None = None
    organizationCategories: list[str] | None = None
    organizationTypes: list[str] | None = None
    organizationZipCodes: list[str] | None = None
    organizationCities: list[str] | None = None
    organizationRegions: list[str] | None = None
    organizationDepartments: list[str] | None = None
    organizationFiscalReceiptEligibility: bool | None = None
    organizationLinkedPartners: list[str] | None = None


class ListOrganizationsRequest(BaseModel):
    name: str | None = None
    description: str | None = None
    categories: list[str] | None = None
    types: list[str] | None = None
    zipCodes: list[str] | None = None
    cities: list[str] | None = None
    regions: list[str] | None = None
    departments: list[str] | None = None
    fiscalReceiptEligibility: bool | None = None
    internalTags: list[str] | None = None
    tags: list[str] | None = None
    linkedPartners: list[str] | None = None


class DirectoryOrganizationPublicModel(BaseModel):
    tags: list[str] | None = None
    linkedPartners: list[str] | None = None
    isAuthenticated: bool | None = None
    banner: str | None = None
    fiscalReceiptEligibility: bool | None = None
    fiscalReceiptIssuanceEnabled: bool | None = None
    type: enums.OrganizationType | None = None
    category: str | None = None
    address: str | None = None
    geolocation: shared.GeoLocation | None = None
    rnaNumber: str | None = None
    logo: str | None = None
    name: str | None = None
    role: enums.GlobalRole | None = None
    city: str | None = None
    zipCode: str | None = None
    description: str | None = None
    updateDate: datetime | None = None
    url: str | None = None
    organizationSlug: str | None = None


class SynchronizableFormModel(BaseModel):
    action: enums.RecordActionType | None = None
    record: forms.FormBasicModel | None = None


class SynchronizableOrganizationModel(BaseModel):
    action: enums.RecordActionType | None = None
    record: organization.OrganizationBasicModel | None = None


class PartnerOrganizationModel(BaseModel):
    organization: DirectoryOrganizationPublicModel | None = None
    availableAccessToken: bool | None = None
